"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (bundles) {
  return bundles.map(bundle => {
    if (bundle.type === "css") {
      throw new Error("CSS plugin does not support CSS entry points in `object` mode.");
    }
    if (bundle.type !== "javascript") {
      return bundle;
    }

    return (0, _lodash.assign)({}, bundle, {
      modules: bundle.modules.map(module => {
        if (module.type !== "css") {
          return module;
        }

        const rules = (0, _lodash.chain)(module.ast.nodes).map(node => {
          const ruleset = (0, _lodash.chain)(node.nodes).map(decl => [decl.prop, decl.value]).fromPairs().value();
          return [node.selector, ruleset];
        }).fromPairs().value();

        return (0, _lodash.assign)({}, module, {
          type: "javascript",
          ast: exportObjTmpl({
            EXPORT_VALUE: (0, _ast.fromObject)(rules)
          })
        });
      })
    });
  });
};

var _lodash = require("lodash");

var _babelTypes = require("babel-types");

var t = _interopRequireWildcard(_babelTypes);

var _ast = require("interlock/lib/util/ast");

var _getTemplate = require("./get-template");

var _getTemplate2 = _interopRequireDefault(_getTemplate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

const exportObjTmpl = (0, _getTemplate2.default)("export-object", node => t.program([node]));

module.exports = exports['default'];