"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = generateStyleLoaders;

var _lodash = require("lodash");

var _babelTypes = require("babel-types");

var t = _interopRequireWildcard(_babelTypes);

var _ast = require("interlock/lib/util/ast");

var _getTemplate = require("./get-template");

var _getTemplate2 = _interopRequireDefault(_getTemplate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

const styleLoaderTmpl = (0, _getTemplate2.default)("style-loader", body => t.program(body));

function generateStyleLoaders(bundles, compiledModules, moduleClassnameMaps) {
  // TODO: The modules belonging to CSS bundles (specified in `entry`) should
  //       not be transformed here.  Too much extra work.  Instead, create a
  //       memoized function here that will return a JavaScript module that
  //       was created from the original CSS module.
  const jsifiedModules = compiledModules.reduce((jsified, module) => {
    if (module.type === "css") {
      jsified[module.hash] = (0, _lodash.assign)({}, module, {
        type: "javascript",
        ast: styleLoaderTmpl({
          STYLE_ID: t.stringLiteral(module.hash),
          RULES: t.stringLiteral(escape(module.ast.toString())),
          EXPORT_VALUE: moduleClassnameMaps && moduleClassnameMaps[module.path] ? (0, _ast.fromObject)(moduleClassnameMaps[module.path]) : t.identifier("stylesheet")
        })
      });
    }
    return jsified;
  }, {});

  return bundles.map(bundle => {
    return bundle.type === "javascript" ? (0, _lodash.assign)({}, bundle, {
      modules: bundle.modules.map(module => jsifiedModules[module.hash] || module)
    }) : bundle;
  });
}
module.exports = exports['default'];