"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getTemplate;

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _fs = require("fs");

var _fs2 = _interopRequireDefault(_fs);

var _template2 = require("interlock/lib/util/template");

var _template3 = _interopRequireDefault(_template2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getTemplate(templateName, transform) {
  transform = transform || (node => node);
  const absPath = _path2.default.join(__dirname, `../templates/${ templateName }.jst`);
  const templateStr = _fs2.default.readFileSync(absPath, "utf-8")
  // Remove ESlint rule exclusions from parsed templates.
  .replace(/\s*\/\/\s*eslint-disable-line.*/g, "");
  const _template = (0, _template3.default)(templateStr);
  return opts => transform(_template(opts));
}
module.exports = exports['default'];